import ReactSelect from 'react-select';
import { createComponent } from '@cloudflare/style-container';
const Option = createComponent(({
  theme,
  isSelected,
  isFocused,
  isDisabled
}) => {
  const color = isSelected || isFocused ? theme.colors.gray[1] : theme.colors.gray[4];
  let backgroundColor = theme.colors.white;

  if (isFocused) {
    backgroundColor = theme.colors.gray[8];
  } else if (isSelected) {
    backgroundColor = theme.colors.gray[9];
  }

  return {
    boxSizing: 'border-box',
    cursor: 'pointer',
    display: 'block',
    padding: '8px 10px',
    opacity: isDisabled ? 0.5 : 1,
    backgroundColor,
    color,
    '& [role="option"]': {
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    }
  };
}, ReactSelect.defaultProps.optionComponent);
export default Option;