import React from 'react';
import PropTypes from 'prop-types';
import { createComponent } from '@cloudflare/style-container';
const ArrowRendererWrapper = createComponent(({
  theme,
  isOpen,
  invert
}) => ({
  borderColor: isOpen ? `transparent transparent ${invert ? theme.colors.white : theme.colors.blue[4]}` : `${invert ? theme.colors.white : theme.colors.blue[4]} transparent transparent`,
  borderWidth: isOpen ? `0 5px 5px` : '5px 5px 2.5px',
  borderStyle: 'solid',
  display: 'inline-block',
  height: 0,
  width: 0
}));
export default function actionArrowRenderer({
  onMouseDown
}) {
  return /*#__PURE__*/React.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown
  });
}
export function actionArrowRendererInvert({
  onMouseDown
}) {
  return /*#__PURE__*/React.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown,
    invert: true
  });
}
const propTypes = {
  onMouseDown: PropTypes.func
};
actionArrowRenderer.propTypes = propTypes;
actionArrowRendererInvert.propTypes = propTypes;