import React from 'react';
import PropTypes from 'prop-types';
import { createComponent } from '@cloudflare/style-container';
const ArrowRendererWrapper = createComponent(({
  theme,
  isOpen
}) => ({
  borderColor: isOpen ? `transparent transparent ${theme.colors.gray[4]}` : `${theme.colors.gray[4]} transparent transparent`,
  borderWidth: isOpen ? `0 5px 5px` : '5px 5px 2.5px',
  borderStyle: 'solid',
  display: 'inline-block',
  height: 0,
  width: 0
}));
export default function arrowRenderer({
  onMouseDown
}) {
  return /*#__PURE__*/React.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown
  });
}
arrowRenderer.propTypes = {
  onMouseDown: PropTypes.func
};