// These type definitions are currently non-functional, as the ReactSelectProps import from 'react-select' doesn't resolve
import * as React from 'react';
import { ReactSelectProps } from 'react-select';
import { TfelaMProps } from '@cloudflare/types';

export type TSelectProps = Omit<
  ReactSelectProps<any>,
  'onChange' | 'arrowRenderer'
> & {
  menuRenderer?: any;
  menuTitle?: string;
  menuHeaderComponent?: any;
  closeMenuComponent?: any;
  creatable?: boolean;
  async?: boolean;
  label?: React.ReactNode;
  onChange?: (...arg: any[]) => void;
  autoComplete?: any;
  testId?: string;
  loadOptions?: (input: string) => Promise<ILoadResult>;
  autoload?: boolean;
  cache?: boolean;
  searchPromptText?: string;
  notClearable?: boolean;
  isValidNewOption?: (item: any) => boolean;
  newOptionCreator?: (item: any) => TSelectOption;
  promptTextCreator?: (label: string) => string;
  innerRef?: React.Ref<HTMLSelectElement>;
  // Action selects are intended to perform an action on selection, rather than
  // action selecting an item
  action?: boolean;
  // Currently only applies with the action property. Inverts the appearance on
  // the select to appear like a button.
  invert?: boolean;
  arrowRenderer?: false | React.FC<{ isOpen: boolean }>;
  onBlurResetsInput?: boolean;
  onCloseResetsInput?: boolean;
  invalid?: boolean;
};

export class Select extends React.Component<TSelectProps & TfelaMProps> {}
export class Option extends React.Component<TfelaMProps> {}
export class SelectUnstyled extends Select {}
export const SelectTheme: { [key: string]: string };
export type TSelectOption<Value = any> = {
  label: string;
  value: Value;
  clearableValue?: boolean;
};
export interface ILoadResult {
  options: TSelectOption[];
}
