"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactSelect = _interopRequireDefault(require("react-select"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Option = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme,
      isSelected = _ref.isSelected,
      isFocused = _ref.isFocused,
      isDisabled = _ref.isDisabled;
  var color = isSelected || isFocused ? theme.colors.gray[1] : theme.colors.gray[4];
  var backgroundColor = theme.colors.white;

  if (isFocused) {
    backgroundColor = theme.colors.gray[8];
  } else if (isSelected) {
    backgroundColor = theme.colors.gray[9];
  }

  return {
    boxSizing: 'border-box',
    cursor: 'pointer',
    display: 'block',
    padding: '8px 10px',
    opacity: isDisabled ? 0.5 : 1,
    backgroundColor: backgroundColor,
    color: color,
    '& [role="option"]': {
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    }
  };
}, _reactSelect.default.defaultProps.optionComponent);
var _default = Option;
exports.default = _default;