"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSelect = _interopRequireWildcard(require("react-select"));

var _styleContainer = require("@cloudflare/style-container");

var _styleConst = require("@cloudflare/style-const");

var _intlReact = require("@cloudflare/intl-react");

var _Value = _interopRequireDefault(require("./Value"));

var _Option = _interopRequireDefault(require("./Option"));

var _MenuHeader = _interopRequireDefault(require("./MenuHeader"));

var _CloseMenu = _interopRequireDefault(require("./CloseMenu"));

var _menuRenderer = _interopRequireDefault(require("./menuRenderer"));

var _arrowRenderer = _interopRequireDefault(require("./arrowRenderer"));

var _actionArrowRenderer = _interopRequireWildcard(require("./actionArrowRenderer"));

var _clearRenderer = _interopRequireDefault(require("./clearRenderer"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Label = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: 'block',
    fontSize: theme.fontSizes[2],
    color: theme.colors.gray[1],
    marginBottom: theme.space[1]
  };
}, 'label'); // bindRight is used to ensure that menuRenderer, called from within react-select,
// is always passed a second parameter which is used for further configuration.

var bindRight = function bindRight(fn) {
  for (var _len = arguments.length, rightArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    rightArgs[_key - 1] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return fn.apply(void 0, args.concat(rightArgs));
  };
};

var Select = /*#__PURE__*/function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));
    _this.menuRenderer = bindRight(props.menuRenderer, {
      menuTitle: props.menuTitle,
      menuHeaderComponent: props.menuHeaderComponent,
      closeMenuComponent: props.closeMenuComponent,
      closeMenu: function closeMenu() {
        return _this.select.closeMenu();
      }
    });
    return _this;
  }

  _createClass(Select, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          async = _this$props.async,
          creatable = _this$props.creatable,
          searchable = _this$props.searchable,
          label = _this$props.label,
          className = _this$props.className,
          multi = _this$props.multi,
          clearable = _this$props.clearable,
          notClearable = _this$props.notClearable,
          onChange = _this$props.onChange,
          testId = _this$props.testId,
          action = _this$props.action,
          invert = _this$props.invert,
          arrowRenderer = _this$props.arrowRenderer,
          props = _objectWithoutProperties(_this$props, ["async", "creatable", "searchable", "label", "className", "multi", "clearable", "notClearable", "onChange", "testId", "action", "invert", "arrowRenderer"]);

      var SelectClass;

      if (async) {
        SelectClass = creatable ? _reactSelect.AsyncCreatable : _reactSelect.Async;
      } else {
        SelectClass = creatable ? _reactSelect.Creatable : _reactSelect.default;
      } // this logic sucks, but it's the only way to be backwards compatible
      // and work for this use case -- https://jira.cfops.it/browse/CUSTESC-2094


      var isClearable = !notClearable && (searchable || creatable || multi || clearable); // Ref access differs depending on whether creatable is used

      props[creatable ? 'innerRef' : 'ref'] = function (ref) {
        return _this2.select = ref;
      };

      var handleChange = function handleChange(e) {
        if (onChange) {
          onChange(e);
        }
      };

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(className),
        "data-testid": testId
      }, label && /*#__PURE__*/_react.default.createElement(Label, null, label), /*#__PURE__*/_react.default.createElement(SelectClass, _extends({}, props, {
        arrowRenderer: arrowRenderer === undefined ? action ? invert ? _actionArrowRenderer.actionArrowRendererInvert : _actionArrowRenderer.default : _arrowRenderer.default : arrowRenderer,
        onChange: handleChange,
        searchable: searchable,
        clearable: isClearable,
        backspaceRemoves: isClearable,
        menuRenderer: this.menuRenderer,
        multi: multi
      })));
    }
  }]);

  return Select;
}(_react.default.Component);

Select.defaultProps = {
  multi: false,
  searchable: false,
  async: false,
  creatable: false,
  clearable: false,
  notClearable: false,
  disabled: false,
  menuRenderer: _menuRenderer.default,
  clearRenderer: _clearRenderer.default,
  optionComponent: _Option.default,
  valueComponent: _Value.default,
  menuHeaderComponent: _MenuHeader.default,
  closeMenuComponent: _CloseMenu.default,
  // Using the `_` prop allows us to default to text when used outside of dash.
  placeholder: /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
    id: "common.select",
    _: "Select..."
  })
};
Select.propTypes = {
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  label: _propTypes.default.node,
  value: _propTypes.default.any,
  options: _propTypes.default.array,
  searchable: _propTypes.default.bool,
  multi: _propTypes.default.bool,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onOpen: _propTypes.default.func,
  async: _propTypes.default.bool,
  creatable: _propTypes.default.bool,
  menuRenderer: _propTypes.default.func,
  arrowRenderer: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.bool]),
  clearRenderer: _propTypes.default.func,
  isValidNewOption: _propTypes.default.func,
  noResultsText: _propTypes.default.string,
  promptTextCreator: _propTypes.default.func,
  newOptionCreator: _propTypes.default.func,
  menuTitle: _propTypes.default.string,
  menuHeaderComponent: _propTypes.default.func,
  closeMenuComponent: _propTypes.default.func,
  loadOptions: _propTypes.default.func,
  autoload: _propTypes.default.bool,
  searchPromptText: _propTypes.default.string,
  cache: _propTypes.default.bool,
  clearable: _propTypes.default.bool,
  notClearable: _propTypes.default.bool,
  placeholder: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),
  testId: _propTypes.default.string,
  action: _propTypes.default.bool,
  invert: _propTypes.default.bool,
  onBlurResetsInput: _propTypes.default.bool,
  onCloseResetsInput: _propTypes.default.bool,
  invalid: _propTypes.default.bool
};

var singleOrPlaceholder = function singleOrPlaceholder(theme, isPlaceholder, action, invert) {
  return {
    bottom: 0,
    color: action ? invert ? theme.colors.white : theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4] : theme.colors.gray[isPlaceholder ? 4 : 1],
    left: 0,
    lineHeight: '32px',
    paddingLeft: '10px',
    paddingRight: '10px',
    position: 'absolute',
    right: 0,
    top: 0,
    maxWidth: 'calc(100% - 29px)',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  };
};

var styles = function styles(_ref2) {
  var theme = _ref2.theme,
      disabled = _ref2.disabled,
      action = _ref2.action,
      invert = _ref2.invert,
      invalid = _ref2.invalid;
  var values = {
    boxSizing: 'border-box',
    fontSize: theme.fontSizes[2]
  };
  return _objectSpread({}, values, {
    '& div': values,
    '& input': values,
    '& span': values,
    flex: 'initial',
    margin: 'initial',
    width: '100%',
    display: 'initial',
    verticalAlign: 'initial',
    position: 'relative',
    textAlign: 'left',
    '& .Select-control': {
      backgroundColor: disabled ? theme.colors.gray[8] : action && invert ? theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4] : theme.colors.white,
      border: '1px solid',
      borderColor: invalid ? theme.colors.red[3] : action ? theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4] : theme.colors.gray[(0, _styleConst.isDarkMode)() ? 4 : 5],
      borderRadius: theme.radii[2],
      color: action && invert ? theme.colors.white : theme.colors.gray[1],
      cursor: disabled ? 'default' : 'pointer',
      display: 'table',
      borderSpacing: 0,
      borderCollapse: 'separate',
      height: '35px',
      outline: 'none',
      overflow: 'hidden',
      position: 'relative',
      tableLayout: 'fixed',
      width: '100%',
      transition: 'border-color 0.2s ease',
      opacity: disabled ? 0.5 : 1,
      paddingBottom: theme.space[1]
    },
    '& .Select-control .Select-input:focus': {
      outline: 'none'
    },
    '& .Select-menu-outer': {
      position: 'relative'
    },
    '&:hover .Select-control': {
      borderColor: invalid ? theme.colors.red[3] : disabled ? theme.colors.gray[(0, _styleConst.isDarkMode)() ? 4 : 5] : theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4]
    },
    '& .is-open .Select-control': {
      borderColor: action ? theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4] : theme.colors.gray[(0, _styleConst.isDarkMode)() ? 4 : 5]
    },
    '& .is-focused .Select-control': _objectSpread({
      borderColor: invalid ? theme.colors.red[3] : theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4]
    }, action && !invert ? {
      border: "2px solid ".concat(theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4])
    } : {}, {
      boxShadow: "".concat(theme.colors.background, " 0px 0px 0px 3px, ").concat(invalid ? theme.colors.red[3] : theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 4], " 0px 0px 0px 5px")
    }),
    '& .Select-placeholder': singleOrPlaceholder(theme, true, action, invert),
    '& .is-focused.is-searchable .Select-placeholder': {
      display: 'none'
    },
    '& .Select--single > .Select-control .Select-value': singleOrPlaceholder(theme, false),
    '& .Select--multi > .Select-control .Select-value': {
      padding: '0 5px 1px 5px',
      minHeight: '23px',
      display: 'flex',
      flexDirection: 'row-reverse',
      alignItems: 'center'
    },
    '& .Select--multi > .Select-control .Select-value-label': {
      padding: '0px',
      top: '0px',
      overflowWrap: 'break-word',
      wordBreak: 'break-all'
    },
    '& .Select--multi > .Select-control .Select-value-icon': {
      padding: '0px 5px 1px 5px'
    },
    '& .Select-input': {
      verticalAlign: 'middle',
      overflow: 'hidden',
      maxWidth: 'calc(100%)',
      marginTop: '4px'
    },
    '& .Select-input > input': {
      color: theme.colors.gray[2],
      width: '100%',
      background: 'none transparent',
      border: ' 0 none',
      cursor: 'default',
      display: 'inline-block',
      fontFamily: 'inherit',
      fontSize: 'inherit',
      height: '100%',
      marginLeft: theme.space[2],
      marginRight: theme.space[2],
      marginTop: 0,
      marginBottom: 0,
      outline: 'none',
      padding: 0,
      transition: 'none'
    },
    '& .Select-noresults': {
      boxVizing: 'border-box',
      color: theme.colors.gray[4],
      cursor: 'default',
      display: 'block',
      padding: theme.space[2]
    },
    '& .Select-aria-only': {
      border: 0,
      clip: 'rect(0, 0, 0, 0)',
      clipPath: 'inset(50%)',
      height: 'auto',
      width: '1px',
      margin: 0,
      padding: 0,
      overflow: 'hidden',
      position: 'absolute',
      whiteSpace: 'nowrap'
    },
    '& .Select-arrow-zone': {
      cursor: disabled ? 'default' : 'pointer',
      display: 'table-cell',
      position: 'relative',
      textAlign: 'center',
      verticalAlign: 'middle',
      width: '25px',
      paddingRight: theme.space[1],
      top: '1px',
      pointerEvents: 'none'
    },
    '& .Select-clear-zone': {
      color: theme.colors.gray[4],
      cursor: ' pointer',
      display: 'table-cell',
      position: 'relative',
      textAlign: 'center',
      verticalAlign: 'middle',
      width: '17px'
    }
  });
};

Select.displayName = 'Select';

var _default = (0, _styleContainer.createStyledComponent)(styles, Select);

exports.default = _default;