"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ValueComponent = function ValueComponent(_ref) {
  var className = _ref.className,
      props = _objectWithoutProperties(_ref, ["className"]);

  var key = props.id + '-key';
  return /*#__PURE__*/_react.default.createElement("div", {
    className: className,
    key: key
  }, /*#__PURE__*/_react.default.createElement(_reactSelect.default.defaultProps.valueComponent, props));
};

ValueComponent.propTypes = {
  className: _propTypes.default.string,
  children: _propTypes.default.node,
  disabled: _propTypes.default.bool,
  id: _propTypes.default.string,
  onClick: _propTypes.default.func,
  onRemove: _propTypes.default.func,
  value: _propTypes.default.object.isRequired
};
ValueComponent.displayName = 'Value';
var Value = (0, _styleContainer.createComponent)(function (_ref2) {
  var theme = _ref2.theme,
      onRemove = _ref2.onRemove,
      disabled = _ref2.disabled;
  // onRemove implies it's a multi-select value
  if (onRemove) return {
    backgroundColor: theme.colors.gray[9],
    border: "1px solid ".concat(theme.colors.gray[7]),
    color: theme.colors.gray[3],
    display: 'inline-block',
    fontSize: '.86667rem',
    marginLeft: '4px',
    marginTop: '4px',
    verticalAlign: 'top',
    '& .Select-value-icon': {
      cursor: disabled ? 'not-allowed' : 'pointer',
      padding: '3px 5px 1px 5px',
      display: 'inline-block',
      verticalAlign: 'middle',
      float: 'right'
    },
    '& .Select-value-icon:hover': {
      color: theme.colors.gray[3]
    },
    '& .Select-value-icon:focus': {
      backgroundColor: theme.colors.gray[7],
      color: theme.colors.gray[3]
    },
    '& .Select-value-icon:active': {
      backgroundColor: theme.colors.gray[7]
    },
    '& .Select-value-label': {
      cursor: 'default',
      padding: '2px 1px 2px 8px',
      position: 'relative',
      top: '2px'
    },
    '& .Select--multi a.Select-value-label': {
      color: theme.colors.blue[4],
      cursor: 'pointer',
      textDecoration: 'none'
    },
    '& .Select--multi a.Select-value-label:hover': {
      textDecoration: 'underline'
    }
  };
  return {
    bottom: 0,
    color: theme.colors.gray[1],
    left: 0,
    lineHeight: '32px',
    paddingLeft: '10px',
    paddingRight: '10px',
    position: 'absolute',
    right: 0,
    top: 0,
    maxWidth: '100%',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  };
}, ValueComponent);
var _default = Value;
exports.default = _default;