"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = actionArrowRenderer;
exports.actionArrowRendererInvert = actionArrowRendererInvert;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArrowRendererWrapper = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme,
      isOpen = _ref.isOpen,
      invert = _ref.invert;
  return {
    borderColor: isOpen ? "transparent transparent ".concat(invert ? theme.colors.white : theme.colors.blue[4]) : "".concat(invert ? theme.colors.white : theme.colors.blue[4], " transparent transparent"),
    borderWidth: isOpen ? "0 5px 5px" : '5px 5px 2.5px',
    borderStyle: 'solid',
    display: 'inline-block',
    height: 0,
    width: 0
  };
});

function actionArrowRenderer(_ref2) {
  var onMouseDown = _ref2.onMouseDown;
  return /*#__PURE__*/_react.default.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown
  });
}

function actionArrowRendererInvert(_ref3) {
  var onMouseDown = _ref3.onMouseDown;
  return /*#__PURE__*/_react.default.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown,
    invert: true
  });
}

var propTypes = {
  onMouseDown: _propTypes.default.func
};
actionArrowRenderer.propTypes = propTypes;
actionArrowRendererInvert.propTypes = propTypes;