"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = arrowRenderer;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArrowRendererWrapper = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme,
      isOpen = _ref.isOpen;
  return {
    borderColor: isOpen ? "transparent transparent ".concat(theme.colors.gray[4]) : "".concat(theme.colors.gray[4], " transparent transparent"),
    borderWidth: isOpen ? "0 5px 5px" : '5px 5px 2.5px',
    borderStyle: 'solid',
    display: 'inline-block',
    height: 0,
    width: 0
  };
});

function arrowRenderer(_ref2) {
  var onMouseDown = _ref2.onMouseDown;
  return /*#__PURE__*/_react.default.createElement(ArrowRendererWrapper, {
    onMouseDown: onMouseDown
  });
}

arrowRenderer.propTypes = {
  onMouseDown: _propTypes.default.func
};