"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = menuRenderer;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

var _ScrollContainer = _interopRequireDefault(require("./ScrollContainer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MenuWrapper = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme;
  return {
    border: "1px solid ".concat(theme.colors.gray[5]),
    borderRadius: theme.borderRadius,
    backgroundColor: theme.colors.white,
    marginTop: '5px',
    boxSizing: 'border-box',
    position: 'absolute',
    top: '100%',
    minWidth: '100%',
    maxWidth: '350px',
    zIndex: '1100',
    webkitOverflowScrolling: 'touch'
  };
});

function menuRenderer(_ref2, _ref3) {
  var focusedOption = _ref2.focusedOption,
      instancePrefix = _ref2.instancePrefix,
      onFocus = _ref2.onFocus,
      onSelect = _ref2.onSelect,
      optionComponent = _ref2.optionComponent,
      optionRenderer = _ref2.optionRenderer,
      options = _ref2.options,
      valueArray = _ref2.valueArray,
      valueKey = _ref2.valueKey,
      onOptionRef = _ref2.onOptionRef;
  var menuTitle = _ref3.menuTitle,
      closeMenu = _ref3.closeMenu,
      closeMenuComponent = _ref3.closeMenuComponent,
      menuHeaderComponent = _ref3.menuHeaderComponent;
  var MenuHeader = menuHeaderComponent;
  var CloseMenu = closeMenuComponent;
  var Option = optionComponent;
  var opts = options.map(function (option, i) {
    var isSelected = valueArray && valueArray.indexOf(option) > -1;
    var isFocused = option === focusedOption;
    return /*#__PURE__*/_react.default.createElement(Option, {
      instancePrefix: instancePrefix,
      isDisabled: option.disabled,
      isFocused: isFocused,
      isSelected: isSelected,
      onFocus: onFocus,
      onSelect: onSelect,
      option: option,
      optionIndex: i,
      ref: function ref(_ref4) {
        onOptionRef(_ref4, isFocused);
      },
      key: "option-".concat(i, "-").concat(option[valueKey])
    }, optionRenderer(option, i));
  });
  return /*#__PURE__*/_react.default.createElement(MenuWrapper, null, menuTitle && /*#__PURE__*/_react.default.createElement(MenuHeader, null, /*#__PURE__*/_react.default.createElement("span", null, menuTitle), /*#__PURE__*/_react.default.createElement(CloseMenu, {
    closeMenu: closeMenu
  })), /*#__PURE__*/_react.default.createElement(_ScrollContainer.default, null, opts));
}

menuRenderer.propTypes = {
  focusedOption: _propTypes.default.object,
  instancePrefix: _propTypes.default.string,
  onFocus: _propTypes.default.func,
  onSelect: _propTypes.default.func,
  optionComponent: _propTypes.default.element,
  optionRenderer: _propTypes.default.func,
  options: _propTypes.default.array,
  valueArray: _propTypes.default.array,
  valueKey: _propTypes.default.string,
  onOptionRef: _propTypes.default.func
};